@import 'src/assets/scss/core/functions';
@import "src/assets/scss/core/breakpoints";
@import "src/assets/scss/core/mixins";
@import "src/assets/scss/settings";

.checkbox {
  display: inline-flex;
  vertical-align: middle;
  text-align: left;
  user-select: none;

  &__input {
    display: none;
    visibility: hidden;
  }

  &__body {
    position: relative;
    display: inline-grid;
    grid-auto-columns: 20px auto 18px;
    grid-column-gap: 10px;
    grid-row-gap: 5px;
    align-items: center;
    font-family: $font-family--secondary;

    @include hover {
      .checkbox__input:not(:disabled) ~ & {

        &::before {
          border-color: $primary-color;
        }

        .checkbox__label {
          color: $gray-dark-color;
        }

        .checkbox__meta {
          color: lighten($gray-dark-color, 15%);
        }
      }
    }

    &::before {
      content: '';
      grid-column: 1 / 2;
      grid-row: 1 / 2;
      align-self: start;
      width: 20px;
      height: 20px;
      box-sizing: border-box;
      border: 1px solid $gray-light-color;
      background-color: $white-color;
      //border-radius: calc(#{$border-radius} / 2);

      .checkbox__input:checked ~ & {
        background-color: $primary-color;
        border-color: $primary-color;
      }

      .checkbox__input:disabled ~ & {
        background-color: $gray-light-color;
        border-color: $gray-light-color;
        cursor: not-allowed;
      }

      .checkbox--invalid & {
        border-color: $red-color;
      }

      .checkbox--inverted .checkbox__input:checked ~ & {
        background-color: $white-color;
      }
    }

    &::after {
      content: "";
      position: relative;
      top: 6px;
      grid-column: 1 / 2;
      grid-row: 1 / 2;
      justify-self: center;
      align-self: start;
      width: 9px;
      height: 4px;
      display: none;
      border-bottom: 2px solid $black-color;
      border-left: 2px solid $black-color;
      transform: rotate(-50deg);

      .checkbox__input:checked ~ & {
        display: block;
      }

      .checkbox__input:disabled ~ & {
        border-bottom-color: $gray-color;
        border-left-color: $gray-color;
      }
    }
  }

  &__top {
    position: relative;
    grid-column: 2 / 3;
    grid-row: 1 / 2;
    justify-self: start;
  }

  &__label {
    font-family: var(--font-text);
    font-size: 16px;
    line-height: 20px;
    //color: $font-color;
    cursor: pointer;

    .checkbox__input:disabled ~ .checkbox__body & {
      opacity: 0.3;
      cursor: not-allowed;
    }

    .checkbox--invalid & {
      color: $red-color;
    }

    .checkbox--sm & {
      font-size: 12px;
    }

    .checkbox--md & {
      font-size: 14px;
    }
  }

  &__help {
    @include btn-default();

    position: relative;
    display: flex;
    grid-column: 3 / 4;
    grid-row: 1 / 2;
    align-self: start;

    &:empty {
      display: none;
    }

    ::ng-deep svg {
      --circle-color: #F2F2F2;
      --circle-bg-color: none;
      --question-color: #999999;

      @include hover {
        --circle-color: #FFDC00;
        --circle-bg-color: #FFDC00;
        --question-color: #000000;
      }
    }
  }

  &__meta {
    grid-column: 2 / 3;
    grid-row: 2 / 3;
    font-size: 14px;
    line-height: 1.2;
    color: $gray-dark-color;
    cursor: pointer;

    &:empty {
      display: none;
    }

    .checkbox__input:disabled ~ .checkbox__body & {
      opacity: 0.3;
      cursor: not-allowed;
    }
  }

  &__actions {
    grid-column: 2 / 3;
    grid-row: 3 / 4;

    &:empty {
      display: none;
    }
  }

  &__clear {
    @include close-button($red-color);

    position: absolute;
    top: -10px;
    right: -15px;

    @include hover {
      opacity: 0.8;
    }
  }
}

